			LOAD EQU P1.2
			DIN EQU P1.1
			CLK EQU P1.0
			KEYPAD EQU P2
			K_A EQU P2.0
			K_B EQU P2.1
			K_C EQU P2.2
			K_D EQU P2.3
			K_P EQU P2.4

	NopReg         EQU 0x00
	DecodeModeReg  EQU 0x09
	IntensityReg   EQU 0x0a
	ScanLimitReg   EQU 0x0b
	ShutdownReg    EQU 0x0c
	DisplayTestReg EQU 0x0f
	
	maxregister    equ 28
	maxdata        equ 29
    				
				
		    org 0
			
MAIN:		
			ACALL INIT  //set all four display registers
		   
		   
main2:
			MOV DPTR,#TABLE  //address start of text
		    MOV	R4,#224 
NEXTC:		MOV	R3,#8 			

REPEAT:		MOV R1,#0
			MOV R0,#8
NEXT:		

  //send data in "reverse" order to end up in the right place
			mov maxregister ,R0  ;address column register 8 - 1
						
			MOV A,R1
			ADD A,#24  ; for last display
			MOVC A,@A+DPTR
			mov maxdata ,A
			ACALL Send16			
	
                //send data  to 3rd display
			MOV A,R1
			ADD A,#16 ; 1 place later
			MOVC A,@A+DPTR			
			mov maxdata ,A
			ACALL Send16
	
		
                //send data  to 2nd display
			MOV A,R1
			ADD A,#8  ; 2 places later
			MOVC A,@A+DPTR
			
			mov maxdata ,A
			ACALL Send16
	
                //send data to 1st display
			MOV A,R1			
			MOVC A,@A+DPTR
			mov maxdata ,A
			ACALL Send16
		
			SETB LOAD   //load all 64 bits 

			aCALL DELAY	
			
			//move along
			INC R1
			DEC R0
									
			CJNE R1,#8,NEXT
		
			DJNZ	R3, REPEAT
			INC	DPTR
			DJNZ R4, NEXTC  //count down string length or get next set of chars
			SJMP main2
	


			
;---------------------------------------------------------				

INIT:	
		
		   	//send same data to same register of all four chips
    		mov maxregister ,#ShutdownReg			
			mov maxdata ,#1		;running
			mov R5,#4
ShutdownReg_loop:
            ACALL Send16
			DJNZ R5,ShutdownReg_loop
			SETB LOAD   //load all 64 bits 
			
			mov R5,#4
DecodeMode_loop:
			mov maxregister ,#DecodeModeReg
			mov maxdata ,#00H ;no decoding
            ACALL Send16
			DJNZ R5,DecodeMode_loop
			SETB LOAD   //load all 64 bits 
			
			mov R5,#4
ScanLimitReg_loop:			
			mov maxregister ,#ScanLimitReg
			mov maxdata ,#07h  ; all 8 columns
            ACALL Send16
			DJNZ R5,ScanLimitReg_loop
		    SETB LOAD   //load all 64 bits 
			
			mov R5,#4
IntensityReg_loop:			
	
			mov maxregister ,#IntensityReg
			mov maxdata ,#04 ;set brightness
            ACALL Send16
			DJNZ R5,IntensityReg_loop
			SETB LOAD   //load all 64 bits 
			ret
			


			            

;-------------------------------------------------------------------		
			
			
Send16:			//send 16bits in one call, but do not "load"	
	        CLR LOAD 
        	MOV R7,#8
		
			;send the register address
			mov A,maxregister
loop8:		CLR CLK
			RLC A       ;get top bit
			MOV DIN,C   ;set bit in "DIN"
			SETB CLK    ;clock it in
			DJNZ R7,loop8  ;do 8 times
			
			;send the data
			mov a,maxdata
			MOV R7,#8
loop8_2:	CLR CLK
			RLC A       ;get top bit
			MOV DIN,C   ;set bit in "DIN"
			SETB CLK    ;clock it in
			DJNZ R7,loop8_2  ;do 8 more times
			ret;
			
		    
			

;------------------------------------------------------------------

	
;----------------------------
; DELAY                 2mS
;------------------------------

DELAY:
MOV  R6, #8
DL1:
MOV  R7, #249
DJNZ R7, $
DJNZ R6, DL1
RET 
;-----------------------------------------------------------
				
TABLE:
	
//DB	00H,00H,00H,00H,00H,00H
//DB	00H,00H,00H,00H,00H,00H
	
DB	3EH, 48H, 88H, 48H, 3EH, 00H		;A
DB	0FEH, 92H, 92H, 92H, 6CH, 00H		;B
DB	7CH, 82H, 82H, 82H, 44H, 00H		;C
DB	0FEH, 82H, 82H, 44H, 38H, 00H		;D
DB	0FEH, 92H, 92H, 92H, 82H, 00H		;E
DB	0FEH, 90H, 90H, 90H, 80H, 00H		;F
DB	7CH, 82H, 92H, 94H, 5EH, 00H		;G
DB	0FEH, 10H, 10H, 10H, 0FEH, 00H	;H
DB	00H, 82H, 0FEH, 82H, 00H, 00H		;I
DB	04H, 02H, 82H, 0FCH, 80H, 00H		;J
DB	0FEH, 10H, 28H, 44H, 82H, 00H		;K
DB	0FEH, 02H, 02H, 02H, 02H, 00H		;L
DB	0FEH, 40H, 30H, 40H, 0FEH, 00H	;M
DB	0FEH, 20H, 10H, 08H, 0FEH, 00H	;N
DB	7CH, 82H, 82H, 82H, 7CH, 00H		;O
DB	0FEH, 90H, 90H, 90H, 60H, 00H		;P
DB	7CH, 82H, 8AH, 84H, 7AH, 00H		;Q
DB	0FEH, 90H, 98H, 94H, 62H, 00H		;R
DB	64H, 92H, 92H, 92H, 4CH, 00H		;S
DB	80H, 80H, 0FEH, 80H, 80H, 00H		;T
DB	0FCH, 02H, 02H, 02H, 0FCH, 00H	;U
DB	0F8H, 04H, 02H, 04H, 0F8H, 00H	;V
DB	0FCH, 02H, 1CH, 02H, 0FCH, 00H		;W
DB	0C6H, 28H, 10H, 28H, 66H, 00H		;X
DB	0E0H, 10H, 0EH, 10H, 0E0H, 00H	;Y
DB	86H, 8AH, 92H, 0A2H, 0C2H, 00H	;Z
DB	7CH, 8AH, 92H, 0A2H, 7CH, 00H		;0
DB	00H, 42H, 0FEH, 02H, 00H, 00H		;1
DB	42H, 86H, 8AH, 92H, 62H, 00H		;2
DB	84H, 82H, 0A2H, 0D2H, 8CH, 00H		;3


DB	18H, 28H, 48H, 0FEH, 08H, 00H		;4
DB	0E4H, 0A2H, 0A2H, 0A2H, 9CH, 00H		;5
DB	3CH, 52H, 92H, 92H, 0CH, 00H		;6
DB	80H, 8EH, 90H, 0A0H, 0C0H, 00H	;7
DB	6CH, 92H, 92H, 92H, 6CH, 00H		;8
DB	60H, 92H, 92H, 94H, 78H, 00H		;9

DB	00H,00H,00H,00H,00H,00H,00H,00H



END 
